package com.baidu.maplite.harmonyos.demo.pages;


import com.baidu.mapapi.map.*;
import com.baidu.mapapi.model.LatLng;
import ohos.aafwk.content.Intent;
import ohos.agp.components.Button;
import ohos.agp.components.ComponentContainer;
import ohos.agp.window.dialog.ToastDialog;
import ohos.hiviewdfx.HiLog;

public class AddCircleAbility extends CustomAbility {

    /**
     * mapView
     */
    private MapView mMapView;

    /**
     * mapView控制器
     */
    private BaiduMap mBaiduMap;

    private Circle circle;

    @Override
    public void onStart(Intent intent) {
        super.onStart(intent);
        setWindowBgToAdaptWebView();
        // 添加控件
        initPositionLayout();
        addMapView();
        addButtons();
        super.setUIContent(this.rootLayout);
    }

    @Override
    public void onActive() {
        super.onActive();
        mMapView.onResume();
    }

    @Override
    public void onForeground(Intent intent) {
        super.onForeground(intent);
        mMapView.onPause();
    }

    @Override
    protected void onStop() {
        super.onStop();
        mMapView.onDestroy();
    }
    private void addMapView() {
        // 创建mMapView
        mMapView = new MapView(getContext());
        mMapView.setPosition(0, 0);
        mMapView.setWidth(ComponentContainer.LayoutConfig.MATCH_PARENT);
        mMapView.setHeight(ComponentContainer.LayoutConfig.MATCH_PARENT);
        this.rootLayout.addComponent(mMapView);
        mBaiduMap = mMapView.getMap();
    }

    private void addButtons() {
        // 添加一个按钮
        Button button = createButton();
        button.setContentPosition(0, vp2px(24));
        button.setText("addCircle");
        button.setTouchEventListener((component, touchEvent) -> true);
        // btn 点击事件
        button.setClickedListener(component -> addCircle());
        this.rootLayout.addComponent(button);

        // 添加一个按钮
        Button button2 = createButton();
        button2.setContentPosition(0, vp2px(87));
        button2.setText("remove");
        button2.setTouchEventListener((component, touchEvent) -> true);
        // btn 点击事件
        button2.setClickedListener(component -> removeCircle());
        this.rootLayout.addComponent(button2);

        // 添加一个按钮
        Button button9 = createButton();
        button9.setContentPosition(0, vp2px(150));
        button9.setText("showToast");
        button9.setTouchEventListener((component, touchEvent) -> true);
        // btn 点击事件
        button9.setClickedListener(component -> showToast());
        this.rootLayout.addComponent(button9);
    }


    // 添加Circle
    private void addCircle() {
        if (circle == null) {
            HiLog.debug(TAG, "mapAddCircle");
            CircleOptions circleOptions = new CircleOptions().
                    center(new LatLng(39.915, 116.404)). // 设置圆心坐标，不能包含 null
                    radius(14000). //  圆半径，单位：米
                    stroke(new Stroke(3, 0xAA6495ED)). // 设置圆边框信息
                    fillColor(0xAA00FF00); // 设置圆填充颜色
            circle = (Circle) mBaiduMap.addOverlay(circleOptions);
        } else {
            ToastDialog toastDialog = new ToastDialog(this);
            toastDialog.setText("circle 已存在")
                    .setDuration(5000)
                    .show();
        }

    }

    // 移除Circle
    private void removeCircle() {
        if (circle != null) {
            HiLog.debug(TAG, "mapRemoveCircle");
//        mBaiduMap.clear();
            circle.remove();
            circle = null;
        }
    }

    // 获取circle信息
    private void showToast() {
        if (circle != null) {
            HiLog.debug(TAG, "showToast");
            ToastDialog toastDialog = new ToastDialog(this);
            toastDialog.setText("填充颜色\n" + circle.getFillColor() + "\n圆心坐标\n" + circle.getCenter()
                    + "\n圆半径\n" + circle.getRadius() + "\n边框的宽度:" + circle.getStroke().strokeWidth
                    + "\n边框的颜色:" + circle.getStroke().color)
                    .setDuration(1000)
                    .show();
        }
    }

}


