package com.baidu.maplite.harmonyos.demo.pages;


import com.baidu.mapapi.map.*;
import com.baidu.mapapi.model.LatLng;
import ohos.aafwk.content.Intent;
import ohos.agp.components.Button;
import ohos.agp.components.ComponentContainer;
import ohos.agp.window.dialog.ToastDialog;
import ohos.hiviewdfx.HiLog;

import java.util.ArrayList;
import java.util.List;

public class AddPolygonAbility extends CustomAbility {
    /**
     * mapView
     */
    private MapView mMapView;

    /**
     * mapView控制器
     */
    private BaiduMap mBaiduMap;

    private Polygon polygon;

    @Override
    public void onStart(Intent intent) {
        super.onStart(intent);
        setWindowBgToAdaptWebView();
        // 添加控件
        initPositionLayout();
        addMapView();
        addButtons();
        super.setUIContent(this.rootLayout);
    }

    @Override
    public void onActive() {
        super.onActive();
        mMapView.onResume();
    }

    @Override
    public void onForeground(Intent intent) {
        super.onForeground(intent);
        mMapView.onPause();
    }

    @Override
    protected void onStop() {
        super.onStop();
        mMapView.onDestroy();
    }
    private void addMapView() {
        // 创建mapView
        mMapView = new MapView(getContext());
        mMapView.setPosition(0, 0);
        mMapView.setWidth(ComponentContainer.LayoutConfig.MATCH_PARENT);
        mMapView.setHeight(ComponentContainer.LayoutConfig.MATCH_PARENT);
        this.rootLayout.addComponent(mMapView);
        mBaiduMap = mMapView.getMap();
    }

    private void addButtons() {
        // 添加一个按钮
        Button button = createButton();
        button.setContentPosition(0, vp2px(24));
        button.setText("AddPolygon");
        button.setTouchEventListener((component, touchEvent) -> true);
        // btn 点击事件
        button.setClickedListener(component -> addPolygon());
        this.rootLayout.addComponent(button);

        // 添加一个按钮
        Button button2 = createButton();
        button2.setContentPosition(0, vp2px(87));
        button2.setText("remove");
        button2.setTouchEventListener((component, touchEvent) -> true);
        // btn 点击事件
        button2.setClickedListener(component -> removePolygon());
        this.rootLayout.addComponent(button2);
    }

    // 添加Polygon
    private void addPolygon() {
        if (polygon == null) {
            HiLog.debug(TAG, "mapAddPolygon");
            List<LatLng> points = new ArrayList<>();
            points.add(new LatLng(39.971802, 116.299059));
            points.add(new LatLng(39.848715, 116.297909));
            points.add(new LatLng(39.860679, 116.549722));
            points.add(new LatLng(39.984186, 116.502579));
            PolygonOptions polygonOptions = new PolygonOptions().
                    points(points). // 设置多边形坐标点列表，不能包含 null
                    stroke(new Stroke(3, 0xAA0000CD)). // 设置多边形边框信息
                    fillColor(0xAA6495ED); // 设置多边形填充颜色
            polygon = (Polygon) mBaiduMap.addOverlay(polygonOptions);
        } else {
            ToastDialog toastDialog = new ToastDialog(this);
            toastDialog.setText("Polygon 已存在")
                    .setDuration(5000)
                    .show();
        }
    }

    // 移除Polygon
    private void removePolygon() {
        if (polygon != null) {
            HiLog.debug(TAG, "mapRemovePolygon");
//        mBaiduMap.clear();
            polygon.remove();
            polygon = null;
        }

    }
}

