package com.baidu.maplite.harmonyos.demo.slice;

import com.baidu.maplite.harmonyos.demo.ResourceTable;
import com.baidu.maplite.harmonyos.demo.pages.*;
import ohos.aafwk.ability.AbilitySlice;
import ohos.aafwk.content.Intent;
import ohos.aafwk.content.Operation;
import ohos.agp.components.Component;
import ohos.agp.components.ListContainer;

import java.util.ArrayList;

public class MainAbilitySlice extends AbilitySlice implements ListContainer.ItemClickedListener {
    private ListContainer mListContainer;
    private ArrayList<ItemPage> mPages;

    @Override
    public void onStart(Intent intent) {
        super.setUIContent(ResourceTable.Layout_main_layout);
        mListContainer = (ListContainer) findComponentById(ResourceTable.Id_list_container);
        initData();
        initProvider();
    }

    @Override
    public void onActive() {
        super.onActive();
    }

    @Override
    public void onForeground(Intent intent) {
        super.onForeground(intent);
    }

    @Override
    protected void onStop() {
        super.onStop();
    }

    private void initData() {
        if (mPages == null) {
            mPages = new ArrayList<>();
            mPages.add(new ItemPage("地图展示", ShowMapAbility.class.getName()));
            mPages.add(new ItemPage("添加Marker", AddMarkerAbility.class.getName()));
            mPages.add(new ItemPage("添加Polyline", AddPolylineAbility.class.getName()));
            mPages.add(new ItemPage("添加Polygon", AddPolygonAbility.class.getName()));
            mPages.add(new ItemPage("添加Circle", AddCircleAbility.class.getName()));
        }
    }

    private void initProvider() {
        MainListItemProvider listItemProvider = new MainListItemProvider(getContext(), mPages);
        mListContainer.setItemProvider(listItemProvider);
        mListContainer.setReboundEffect(true);
        mListContainer.setItemClickedListener(MainAbilitySlice.this);
    }

    @Override
    public void onItemClicked(ListContainer listContainer, Component component, int i, long l) {
        ItemPage demo = mPages.get(i);
        if (demo.target != null) {
            goNextPage(demo.target);
        }

    }

    private void goNextPage(String page) {
        Intent intent = new Intent();
        Operation operation = new Intent.OperationBuilder().withDeviceId("")
                .withBundleName(getBundleName())
                .withAbilityName(page)
                .build();
        intent.setOperation(operation);
        intent.setParam("key", "我从MainAbility进到了" + page);
        startAbilityForResult(intent, 1);
    }
}