package com.baidu.maplite.harmonyos.demo.slice;

import com.baidu.maplite.harmonyos.demo.ResourceTable;
import ohos.agp.components.*;
import ohos.app.Context;

import java.util.ArrayList;

public class MainListItemProvider extends BaseItemProvider {
    private final ArrayList<ItemPage> mPages;
    private final Context mContext;

    public MainListItemProvider(Context context, ArrayList<ItemPage> pages) {
        mContext = context;
        mPages = pages;
    }

    @Override
    public int getCount() {
        return mPages.size();
    }

    @Override
    public Object getItem(int i) {
        return mPages.get(i);
    }

    @Override
    public long getItemId(int i) {
        return i;
    }

    @Override
    public Component getComponent(int i, Component component, ComponentContainer componentContainer) {
        if (component == null) {
            component = LayoutScatter.
                    getInstance(componentContainer.getContext()).
                    parse(ResourceTable.Layout_main_list_item, null, false);
        }
        Text text = (Text) component.findComponentById(ResourceTable.Id_item_content_text);
        text.setText(this.mPages.get(i).title);
        Text bText = (Text) component.findComponentById(ResourceTable.Id_item_content__bottom_text);
        String packageName = mContext.getAbilityInfo().getBundleName();
        bText.setText(this.mPages.get(i).target.replace(packageName, ""));
        return component;
    }

}


